
/* 
   If I compile the following very simple program, with cfront3.0 on a sun 
   sparcstation, it crashes with a BUS (alignment) error during the call of 
   inline function F(a) in main.

   It does not crash if I make one of the following changes:
   a) make F a real (not inline) function
   b) uncomment the first line (cout << ...) in F's definition
   c) delete the the last line (cout << ...) in F's definition
   d) delete the copy constructor A(const A&)


   I would like to know, if this is a bug in cfront3.0 or just a problem 
   with my version, installation, or machine.

*/



#include <stream.h>


class A
{
  public:

  int x;

  A()            { x = 0; }
  A(const A& a)  { x = a.x; }

 };


void ASSIGN_X(A& a, int y)    { a.x = y; } 



inline void F(A a) 
{ 

//cout << "xvalue(a) = " << a.x << endl;

  ASSIGN_X(a,17); 

  cout << "xvalue(a) = " << a.x << endl;

 }



main()
{ 
  A a;

  F(a);

 }
